import {AfterViewInit, Component, ViewChild, ElementRef} from '@angular/core';
import {Observable} from "rxjs/Observable";
import "rxjs/add/observable/combineLatest";
import "rxjs/add/operator/filter";
import "rxjs/add/operator/map";
import {NgForm, FormGroup} from "@angular/forms";

@Component({
  selector: 'app-root',
  styleUrls: ['./app.component.css'],
  //templateUrl: './app.component.html',
  template: `
<form #formRef="ngForm"
  (ngSubmit)="onSubmit(formRef.value)"
  >
  <input
    name="user"
    #usernameRef="ngModel" 
    minlength="3"
    type="text" 
    [(ngModel)]="username"
    required>
  <input
    name="age"
    type="number" 
    [(ngModel)]="age"
    required>
  <button [disabled]="!formRef.valid" type="submit">Submit</button>
<hr>
    {{username}}
    <br>
    Value: {{val | json}}
</form>
`,
})
export class AppComponent implements AfterViewInit {
  age = 213;
  username = 'John';
  val : { name: string, age: number};

  @ViewChild('formRef') form : NgForm;

  ngAfterViewInit() {
    Observable.combineLatest(
        this.form.valueChanges,
        this.form.statusChanges,
        (value, status) => ({'status': status, 'value': value}))
        .filter (o => (o.status === 'VALID'))
        .map (v => v.value)
        .subscribe(v => console.log (v));
  }

  onSubmit (formValue: { name: string, age: number}) {
    this.val = formValue;
  }

  onFocus(x) {
    console.log(x);
  }
}
